// InputTask.cpp: implementation of the CInputTask class.
//
//////////////////////////////////////////////////////////////////////
#ifndef USING_ENGINUITY
#define USING_ENGINUITY
#endif
#include "engine.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//unsigned char *CInputTask::keys=0;
CMMPointer<CMMDynamicBlob<unsigned char> > CInputTask::keys=0;
CMMPointer<CMMDynamicBlob<unsigned char> > CInputTask::oldKeys=0;
int CInputTask::keyCount=0;
int CInputTask::dX=0;
int CInputTask::dY=0;
unsigned int CInputTask::buttons=0;
unsigned int CInputTask::oldButtons=0;


CInputTask::CInputTask()
{

}

CInputTask::~CInputTask()
{

}

bool CInputTask::Start()
{
	unsigned char *tempKeys=SDL_GetKeyState(&keyCount);
	keys=new CMMDynamicBlob<unsigned char>(keyCount);
	memcpy((unsigned char*)(*keys),tempKeys,sizeof(unsigned char)*keyCount);
	oldKeys=new CMMDynamicBlob<unsigned char>(keyCount);
	dX=dY=0;
	SDL_PumpEvents(); SDL_PumpEvents();
	return true;
}

void CInputTask::Update()
{
	SDL_PumpEvents();
	oldButtons=buttons;
	buttons=SDL_GetRelativeMouseState(&dX,&dY);
	memcpy((unsigned char*)(*oldKeys),(unsigned char*)(*keys),sizeof(unsigned char)*keyCount);
	unsigned char *tempKeys=SDL_GetKeyState(&keyCount);
	memcpy((unsigned char*)(*keys),tempKeys,sizeof(unsigned char)*keyCount);
}

void CInputTask::Stop()
{
	keys=0;
	oldKeys=0;
}