// GlobalTimer.cpp: implementation of the CGlobalTimer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef USING_ENGINUITY
#define USING_ENGINUITY
#endif
#include "engine.h"
#include "GlobalTimer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

float CGlobalTimer::dT=0;
unsigned long CGlobalTimer::lastFrameIndex=0;
unsigned long CGlobalTimer::thisFrameIndex=0;

CGlobalTimer::CGlobalTimer()
{

}

CGlobalTimer::~CGlobalTimer()
{

}

bool CGlobalTimer::Start()
{
	Reset();
	return true;
}

void CGlobalTimer::Update()
{
	lastFrameIndex=thisFrameIndex;
	thisFrameIndex=SDL_GetTicks();
	dT=((float)(thisFrameIndex-lastFrameIndex))/1000.0f;
}

void CGlobalTimer::Reset()
{
	thisFrameIndex=SDL_GetTicks();
	lastFrameIndex=thisFrameIndex;
	dT=0;
}

void CGlobalTimer::Stop()
{

}
